"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.makeCustomActions = void 0;

var R = _interopRequireWildcard(require("ramda"));

var _makeActionTemplate = require("../template/makeActionTemplate");

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj["default"] = obj; return newObj; } }

var makeCustomActions = function makeCustomActions() {
  var reducersDict = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
  var pathToLeafOrBranch = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : [];
  var actionTemplate = (0, _makeActionTemplate.makeActionTemplate)(pathToLeafOrBranch, {
    custom: true
  });
  return R.mapObjIndexed(makeCustomActionCreator(actionTemplate), reducersDict);
};

exports.makeCustomActions = makeCustomActions;
var makeCustomActionCreator = R.curry(function (actionTemplate, leafReducer, creatorKey) {
  var argsToPayload = leafReducer.argsToPayload;
  return function () {
    var payload = argsToPayload.apply(void 0, arguments);
    return actionTemplate(creatorKey, payload, leafReducer.type);
  };
});