"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.makeActionTemplate = void 0;

function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _nonIterableSpread(); }

function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance"); }

function _iterableToArray(iter) { if (Symbol.iterator in Object(iter) || Object.prototype.toString.call(iter) === "[object Arguments]") return Array.from(iter); }

function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = new Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } }

var makeActionTemplate = function makeActionTemplate() {
  var path = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : [];

  var _ref = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {},
      condition = _ref.condition,
      custom = _ref.custom;

  return function (modifier, payload) {
    var customType = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : null;
    var type = condition ? "".concat(condition, ".").concat(modifier) : modifier;
    return {
      leaf: {
        path: path,
        condition: condition,
        modifier: modifier,
        custom: custom
      },
      type: customType || [].concat(_toConsumableArray(path), [type]).join('/'),
      payload: payload
    };
  };
};

exports.makeActionTemplate = makeActionTemplate;