"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.leafReducerCustom = void 0;

var _immer = _interopRequireDefault(require("immer"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

var leafReducerCustom = function leafReducerCustom(reducersDict, leafState, action, wholeState) {
  var creatorKey = action.leaf.creatorKey;
  return Object.keys(reducersDict).includes(creatorKey) ? applyReducer(reducersDict[creatorKey], leafState, action, wholeState) : leafState;
};

exports.leafReducerCustom = leafReducerCustom;

var applyReducer = function applyReducer(config, leafState, action, wholeState) {
  if (config.mutate) {
    return (0, _immer["default"])(leafState, function (draftLeafState) {
      config.reducer(draftLeafState, action, wholeState);
    });
  } else {
    return config.reducer(leafState, action, wholeState);
  }
};