"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.leafReducerString = void 0;

var RA = _interopRequireWildcard(require("ramda-adjunct"));

var _atomic = require("../../actions/atomic");

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj["default"] = obj; return newObj; } }

function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _nonIterableSpread(); }

function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance"); }

function _iterableToArray(iter) { if (Symbol.iterator in Object(iter) || Object.prototype.toString.call(iter) === "[object Arguments]") return Array.from(iter); }

function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = new Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } }

var leafReducerString = function leafReducerString(leafState, _ref) {
  var creatorKey = _ref.creatorKey,
      payload = _ref.payload;
  var state = RA.isString(leafState) ? leafState : String(leafState);

  switch (creatorKey) {
    case _atomic.atomicActions.CONCAT:
      return concat.apply(void 0, [state].concat(_toConsumableArray(payload)));

    case _atomic.atomicActions.REPLACE:
      return replace(state, payload);

    default:
      return state;
  }
};

exports.leafReducerString = leafReducerString;

var concat = function concat(leafState) {
  for (var _len = arguments.length, strings = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
    strings[_key - 1] = arguments[_key];
  }

  return leafState.concat.apply(leafState, strings);
};

var replace = function replace(leafState, _ref2) {
  var pattern = _ref2.pattern,
      replacement = _ref2.replacement;
  return leafState.replace(pattern, replacement);
};