"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.standardiseReducersDict = void 0;

var R = _interopRequireWildcard(require("ramda"));

var _defaults = require("./defaults");

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj["default"] = obj; return newObj; } }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; var ownKeys = Object.keys(source); if (typeof Object.getOwnPropertySymbols === 'function') { ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function (sym) { return Object.getOwnPropertyDescriptor(source, sym).enumerable; })); } ownKeys.forEach(function (key) { _defineProperty(target, key, source[key]); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var standardiseReducersDict = function standardiseReducersDict() {
  var reducersDict = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
  return R.mapObjIndexed(defineLeafReducer, reducersDict);
};

exports.standardiseReducersDict = standardiseReducersDict;

var defineLeafReducer = function defineLeafReducer(definition) {
  return typeof definition === "function" ? defineLeafReducerFromFunction(definition) : defineLeafReducerFromConfig(definition);
};

var defineLeafReducerFromConfig = function defineLeafReducerFromConfig(config) {
  return _objectSpread({}, _defaults.leafReducerDefaults, config);
};

var defineLeafReducerFromFunction = function defineLeafReducerFromFunction(callback) {
  return defineLeafReducerFromConfig({
    reducer: callback
  });
};