"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.reduxLeaves = void 0;

var R = _interopRequireWildcard(require("ramda"));

var _actions = require("./actions/");

var _leafReducer = require("./leafReducer");

var _standardiseReducersDict = require("./reducersDict/standardise/standardiseReducersDict");

var _utils = require("./utils");

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj["default"] = obj; return newObj; } }

var reduxLeaves = function reduxLeaves(initialState) {
  var reducersDict = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
  var leafReducersDict = (0, _standardiseReducersDict.standardiseReducersDict)(reducersDict);

  function reducer() {
    var state = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : initialState;
    var action = arguments.length > 1 ? arguments[1] : undefined;
    var _action$leaf = action.leaf,
        leaf = _action$leaf === void 0 ? {} : _action$leaf;
    var _leaf$path = leaf.path,
        path = _leaf$path === void 0 ? [] : _leaf$path,
        condition = leaf.condition,
        creatorKey = leaf.creatorKey,
        custom = leaf.custom; // const prevLeafState = getState(draftState, path)

    var prevLeafState = (0, _utils.getState)(state, path);
    var newLeafState = (0, _leafReducer.leafReducer)(prevLeafState, action, state, initialState, leafReducersDict);
    return (0, _utils.updateState)(state, path, newLeafState);
  }

  var actions = (0, _actions.actionsFor)(R.clone(initialState), leafReducersDict);
  return [reducer, actions];
};

exports.reduxLeaves = reduxLeaves;