"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.updateState = exports.resetState = exports.getState = void 0;

var R = _interopRequireWildcard(require("ramda"));

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj["default"] = obj; return newObj; } }

var getState = function getState(state, path) {
  return pathIsEmpty(path) ? state : Array.isArray(path) ? R.path(path, state) : R.path(path.split('.'), state);
};

exports.getState = getState;

var resetState = function resetState(state, path, initialState) {
  return updateState(state, path, getState(initialState, path));
};

exports.resetState = resetState;

var updateState = function updateState(state, path, val) {
  return pathIsEmpty(path) ? val : Array.isArray(path) ? R.assocPath(path, val, state) : R.assocPath(path.split('.'), val, state);
};

exports.updateState = updateState;

var pathIsEmpty = function pathIsEmpty(path) {
  return ['', null, undefined].includes(path) || path.length === 0;
};